
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>我的Java开发学习之旅------&amp;gt;Base64的编码思想以及Java实现 / iVAN</title>

    <meta name="description" content="我的Java开发学习之旅------&amp;gt;Base64的编码思想以及Java实现 Base64是一种用64个字符来表示任意二进制数据的方法. 用记事本打开exe.jpg.pdf这些文件时,我们都会看到一大堆乱码,因为二进制文件包含很多无法显示和打印的字符,所以,如果要让记事本这样的文本处理软件能处理二进制数据,就需要一个二进制到字符串的转换方法.Base64是一种最常见的二进制编码方法. 一.编码规则 所谓Base64,就是说选出64个字符----小写字母a-z.大写字母A-Z.数字0-9.符号&quot;+&quot;.&quot;/&quot;(再加上作为垫字的&quot ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">我的Java开发学习之旅------&amp;gt;Base64的编码思想以及Java实现</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Base64是一种用64个字符来表示任意二进制数据的方法。</p>
<p>用记事本打开exe、jpg、pdf这些文件时，我们都会看到一大堆乱码，因为二进制文件包含很多无法显示和打印的字符，所以，如果要让记事本这样的文本处理软件能处理二进制数据，就需要一个二进制到字符串的转换方法。Base64是一种最常见的二进制编码方法。</p>
<p>一、编码规则</p>
<p>所谓Base64，就是说选出64个字符----小写字母a-z、大写字母A-Z、数字0-9、符号"+"、"/"（再加上作为垫字的"="，实际上是65个字符）----作为一个基本字符集。然后，其他所有符号都转换成这个字符集中的字符。</p>
<p>具体来说，转换方式可以分为四步。</p>
<ul>
<li>第一步，将每三个字节作为一组，一共是24个二进制位。</li>
<li>第二步，将这24个二进制位分为四组，每个组有6个二进制位。</li>
<li>第三步，在每组前面加两个00，扩展成32个二进制位，即四个字节。</li>
<li>第四步，根据下表，得到扩展后的每个字节的对应符号，这就是Base64的编码值。</li>
</ul>
<p>注：BASE64字符表：ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/</p>
<blockquote><blockquote>
<blockquote></blockquote>
</blockquote>
<blockquote><blockquote>
<blockquote></blockquote>
</blockquote>
</blockquote>
<blockquote><blockquote>
<blockquote>
<table>
<thead>
<tr>
<th>
<strong>Base64 编码表</strong>
</th>
</tr>
</thead>
<tbody>
<tr>
<th>
Value
</th>
<th>
Char
</th>
<td rowspan="18">

</td>
<th>
Value
</th>
<th>
Char
</th>
<td rowspan="18">

</td>
<th>
Value
</th>
<th>
Char
</th>
<td rowspan="18">

</td>
<th>
Value
</th>
<th>
Char
</th>
</tr>
<tr>
<td>0</td>
<td>A</td>
<td>16</td>
<td>Q</td>
<td>32</td>
<td>g</td>
<td>48</td>
<td>w</td>
</tr>
<tr>
<td>1</td>
<td>B</td>
<td>17</td>
<td>R</td>
<td>33</td>
<td>h</td>
<td>49</td>
<td>x</td>
</tr>
<tr>
<td>2</td>
<td>C</td>
<td>18</td>
<td>S</td>
<td>34</td>
<td>i</td>
<td>50</td>
<td>y</td>
</tr>
<tr>
<td>3</td>
<td>D</td>
<td>19</td>
<td>T</td>
<td>35</td>
<td>j</td>
<td>51</td>
<td>z</td>
</tr>
<tr>
<td>4</td>
<td>E</td>
<td>20</td>
<td>U</td>
<td>36</td>
<td>k</td>
<td>52</td>
<td>0</td>
</tr>
<tr>
<td>5</td>
<td>F</td>
<td>21</td>
<td>V</td>
<td>37</td>
<td>l</td>
<td>53</td>
<td>1</td>
</tr>
<tr>
<td>6</td>
<td>G</td>
<td>22</td>
<td>W</td>
<td>38</td>
<td>m</td>
<td>54</td>
<td>2</td>
</tr>
<tr>
<td>7</td>
<td>H</td>
<td>23</td>
<td>X</td>
<td>39</td>
<td>n</td>
<td>55</td>
<td>3</td>
</tr>
<tr>
<td>8</td>
<td>I</td>
<td>24</td>
<td>Y</td>
<td>40</td>
<td>o</td>
<td>56</td>
<td>4</td>
</tr>
<tr>
<td>9</td>
<td>J</td>
<td>25</td>
<td>Z</td>
<td>41</td>
<td>p</td>
<td>57</td>
<td>5</td>
</tr>
<tr>
<td>10</td>
<td>K</td>
<td>26</td>
<td>a</td>
<td>42</td>
<td>q</td>
<td>58</td>
<td>6</td>
</tr>
<tr>
<td>11</td>
<td>L</td>
<td>27</td>
<td>b</td>
<td>43</td>
<td>r</td>
<td>59</td>
<td>7</td>
</tr>
<tr>
<td>12</td>
<td>M</td>
<td>28</td>
<td>c</td>
<td>44</td>
<td>s</td>
<td>60</td>
<td>8</td>
</tr>
<tr>
<td>13</td>
<td>N</td>
<td>29</td>
<td>d</td>
<td>45</td>
<td>t</td>
<td>61</td>
<td>9</td>
</tr>
<tr>
<td>14</td>
<td>O</td>
<td>30</td>
<td>e</td>
<td>46</td>
<td>u</td>
<td>62</td>
<td>+</td>
</tr>
<tr>
<td>15</td>
<td>P</td>
<td>31</td>
<td>f</td>
<td>47</td>
<td>v</td>
<td>63</td>
<td>/</p>
</td>
</tr>
</tbody>
</table>
</blockquote>
</blockquote>
</blockquote>
</blockquote>
<p>因为，Base64将三个字节转化成四个字节，所以Base64编码后的文本，会比原文本大出三分之一左右。</p>
<p>举一个具体的实例，演示英语单词Man如何转成Base64编码。</p>
<table>
<tbody>
<tr>
<th>
文本
</th>
<td colspan="8">
<strong>M</strong>
</td>
<td colspan="8">
<strong>a</strong>
</td>
<td colspan="8">
<strong>n</strong>
</td>
</tr>
<tr>
<th>
ASCII编码
</th>
<td colspan="8">
<strong>77</strong>
</td>
<td colspan="8">
<strong>97</strong>
</td>
<td colspan="8">
<strong>110</strong>
</td>
</tr>
<tr>
<th>
二进制位
</th>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
</tr>
<tr>
<th>
索引
</th>
<td colspan="6">
<strong>19</strong>
</td>
<td colspan="6">
<strong>22</strong>
</td>
<td colspan="6">
<strong>5</strong>
</td>
<td colspan="6">
<strong>46</strong>
</td>
</tr>
<tr>
<th>
Base64编码
</th>
<td colspan="6">
<strong>T</strong>
</td>
<td colspan="6">
<strong>W</strong>
</td>
<td colspan="6">
<strong>F</strong>
</td>
<td colspan="6">
<strong>u</strong>
</td>
</tr>
</tbody>
</table>

<ul>
<li>第一步，"M"、"a"、"n"的ASCII值分别是77、97、110，对应的二进制值是01001101、01100001、01101110，将它们连成一个24位的二进制字符串010011010110000101101110。</li>
<li>第二步，将这个24位的二进制字符串分成4组，每组6个二进制位：010011、010110、000101、101110。</li>
<li>第三步，在每组前面加两个00，扩展成32个二进制位，即四个字节：00010011、00010110、00000101、00101110。它们的十进制值分别是19、22、5、46。</li>
<li>第四步，根据上表，得到每个值对应Base64编码，即T、W、F、u。</li>
</ul>
<p>因此，Man的Base64编码就是TWFu。</p>
<p>我们看看另外不是刚好是3个字节的情况！ </p>
<table>
<tbody>
<tr>
<th>
文本（1 Byte）
</th>
<td colspan="8">
<strong>A</strong>
</td>
<td colspan="8">
<strong><br /></strong>
</td>
<td colspan="8">
<strong><br /></strong>
</td>
</tr>
<tr>
<th>
二进制位
</th>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
</tr>
<tr>
<th>
二进制位（补0）
</th>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
</tr>
<tr>
<th>
Base64编码
</th>
<td colspan="6">
<strong>Q</strong>
</td>
<td colspan="6">
<strong>Q</strong>
</td>
<td colspan="6">
<strong>=</strong>
</td>
<td colspan="6">
<strong>=</strong>
</td>
</tr>
<tr>
<th>
文本（2 Byte）
</th>
<td colspan="8">
<strong>B</strong>
</td>
<td colspan="8">
<strong>C</strong>
</td>
<td colspan="8">
<strong><br /></strong>
</td>
</tr>
<tr>
<th>
二进制位
</th>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong><br /></strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
</tr>
<tr>
<th>
二进制位（补0）
</th>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>1</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>0</strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
<td>
<strong>x</strong>
</td>
</tr>
<tr>
<th>
Base64编码
</th>
<td colspan="6">
<strong>Q</strong>
</td>
<td colspan="6">
<strong>k</strong>
</td>
<td colspan="6">
<strong>M</strong>
</td>
<td colspan="6">
<strong> =</strong>
</td>
</tr>
</tbody>
</table>
<p>因此，A的Base64编码就是QQ==,BC的Base64编码就是QkM=</p>
<p> </p>
<p>二、解码规则</p>
<p>      解码过程就是把4个字节再还原成3个字节再根据不同的数据形式把字节数组重新整理成数据。</p>
<p>三、Java实现Base64</p>
<pre>public class Base64Utils {
	/**
	 * 将一个字节数组转换成base64的字符数组
	 *
	 * @param data
	 *            字节数组
	 * @return base64字符数组
	 */
	private static char[] encode(byte[] data) {
		char[] out = new char[((data.length + 2) / 3) * 4];
		for (int i = 0, index = 0; i &lt; data.length; i += 3, index += 4) {
			boolean quad = false;
			boolean trip = false;
			int val = (0xFF &amp; (int) data[i]);
			val &lt;&lt;= 8;
			if ((i + 1) &lt; data.length) {
				val |= (0xFF &amp; (int) data[i + 1]);
				trip = true;
			}
			val &lt;&lt;= 8;
			if ((i + 2) &lt; data.length) {
				val |= (0xFF &amp; (int) data[i + 2]);
				quad = true;
			}
			out[index + 3] = alphabet[(quad ? (val &amp; 0x3F) : 64)];
			val &gt;&gt;= 6;
			out[index + 2] = alphabet[(trip ? (val &amp; 0x3F) : 64)];
			val &gt;&gt;= 6;
			out[index + 1] = alphabet[val &amp; 0x3F];
			val &gt;&gt;= 6;
			out[index + 0] = alphabet[val &amp; 0x3F];
		}
		return out;
	}

	/**
	 * 将一个base64字符数组解码成一个字节数组
	 *
	 * @param data
	 *            base64字符数组
	 * @return 返回解码以后的字节数组
	 */
	private static byte[] decode(char[] data) {
		int len = ((data.length + 3) / 4) * 3;
		if (data.length &gt; 0 &amp;&amp; data[data.length - 1] == '=')
			--len;
		if (data.length &gt; 1 &amp;&amp; data[data.length - 2] == '=')
			--len;
		byte[] out = new byte[len];
		int shift = 0;
		int accum = 0;
		int index = 0;
		for (int ix = 0; ix &lt; data.length; ix++) {
			int value = codes[data[ix] &amp; 0xFF];
			if (value &gt;= 0) {
				accum &lt;&lt;= 6;
				shift += 6;
				accum |= value;
				if (shift &gt;= 8) {
					shift -= 8;
					out[index++] = (byte) ((accum &gt;&gt; shift) &amp; 0xff);
				}
			}
		}
		if (index != out.length)
			throw new Error("miscalculated data length!");
		return out;
	}

	/**
	 * base64字符集 0..63
	 */
	static private char[] alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="
			.toCharArray();

	/**
	 * 初始化base64字符集表
	 */
	static private byte[] codes = new byte[256];

	static {
		for (int i = 0; i &lt; 256; i++)
			codes[i] = -1;
		for (int i = 'A'; i &lt;= 'Z'; i++)
			codes[i] = (byte) (i - 'A');
		for (int i = 'a'; i &lt;= 'z'; i++)
			codes[i] = (byte) (26 + i - 'a');
		for (int i = '0'; i &lt;= '9'; i++)
			codes[i] = (byte) (52 + i - '0');
		codes['+'] = 62;
		codes['/'] = 63;
	}

	 /**
     * 将字符串通过base64转码
     * @param str 要转码的字符串
     * @return 返回转码后的字符串
     */
    public static String strToBase64Str(String str)
    {
        return new String(encode(str.getBytes()));
    }

    /**
     * 将base64码反转成字符串
     * @param base64Str base64码
     * @return 返回转码后的字符串
     */
    public static String base64StrToStr(String base64Str)
    {
        char[] dataArr = new char[base64Str.length()];
        base64Str.getChars(0, base64Str.length(), dataArr, 0);
        return new String(decode(dataArr));
    }

    /**
     * 将字节数组通过base64转码
     * @param byteArray 字节数组
     * @return 返回转码后的字符串
     */
    public static String byteArrayToBase64Str(byte byteArray[])
    {
        return new String(encode(byteArray));
    }

    /**
     * 将base64码转换成字节数组
     * @param base64Str base64码
     * @return 返回转换后的字节数组
     */
    public static byte[] base64StrToByteArray(String base64Str)
    {
        char[] dataArr = new char[base64Str.length()];
        base64Str.getChars(0, base64Str.length(), dataArr, 0);
        return decode(dataArr);
    }

	/**
	 * @param args
	 * @throws UnsupportedEncodingException
	 */
	public static void main(String[] args) throws Exception {
		String strSrc = "Man";
		String strOut = Base64Utils.strToBase64Str(strSrc);
		System.out.println("源字符串 "+strSrc+" 的Base64码是："+strOut);
		String strOut2 = Base64Utils.base64StrToStr(strOut);
        System.out.println("Base64码 "+strOut+" 的对应源字符串为："+strOut2);  

        byte[] inByteArray={'a','b','c'};
        String base64Str=Base64Utils.byteArrayToBase64Str(inByteArray);
        StringBuilder sb=new StringBuilder();
        sb.append('[');
        for (int i = 0; i &lt; inByteArray.length; i++) {
			sb.append(inByteArray[i]+" ");
		}
        sb.append(']');
        System.out.println("字节数组："+sb+" 的Base64码是："+base64Str);

        byte[] outByteArray=Base64Utils.base64StrToByteArray(base64Str);
        StringBuilder sb2=new StringBuilder();
        sb2.append('[');
        for (int i = 0; i &lt; outByteArray.length; i++) {
			sb2.append(outByteArray[i]+" ");
		}
        sb2.append(']');
        System.out.println("Base64码为"+base64Str+" 的对应字节数组为："+sb2);

	}
}</pre>
<p>运行效果如下：</p>
<pre>源字符串 Man 的Base64码是：TWFu
Base64码 TWFu 的对应源字符串为：Man
字节数组：[97 98 99 ] 的Base64码是：YWJj
Base64码为YWJj 的对应字节数组为：[97 98 99 ]</pre>
<p> </p>
<p>                            ====================================================================================<br />
<br /><strong>  作者：欧阳鹏  欢迎转载，与人分享是进步的源泉！</strong></p>
<p><strong>  转载请保留原文地址：<a href="http://blog.csdn.net/ouyang_peng" rel="external nofollow noreferrer">http://blog.csdn.net/ouyang_peng</a></strong></p>
<p>====================================================================================</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA3MDgyMDE5MTAwODk=.jpg"></p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 18:32:58</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/index/" title="index">index</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/%e5%ad%97%e7%ac%a6%e9%9b%86/" title="字符集">字符集</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>我的Java开发学习之旅------&amp;gt;Base64的编码思想以及Java实现的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN72xdp.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;Java经典面试题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘自张孝祥itcast 从享受生活的角度上来说:&quot;程序员并不是一种最好的职业,我认为两种人可以做程序员,第一,你不做程序员,你就没有什么工作可做,或者说是即使有可以做的工作但是你非常不愿意去做:第二,你非常痴迷和爱好程序,并且在这方面有一些天赋和优势.程序员的结局也是有两种:第一,默默退休,第二以程序员为起点或跳板,注意积累,跟对了好的老板或团队,找到和很好的搭档自己创业,成为IT金领和富翁.&quot; 人们在时间面前是平等的,吾生也有涯,所以,你的经验更丰富点,那不算什么,经验是用时间积累的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7qxZz.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;Java双重检查锁定及单例模式详解（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介:          所有的编程语言都有一些共用的习语.了解和使用一些习语很有用,程序员们花费宝贵的时间来创建.学习和实现这些习语.问题是,稍后经过证明,一些习语并不完全如其所声称的那样,或者仅仅是与描述的功能不符.在 Java 编程语言中,双重检查锁定就是这样的一个绝不应该使用的习语.在本文中,Peter Haggar 介绍了双重检查锁定习语的渊源,开发它的原因和它失效的原因.         单例创建模式是一个通用的编程习语.和多线程一起使用时,必需使用某种类型的同步.在努力创建更有效的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwZ8dp.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;Java字符编码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java开发中,常常会遇到乱码的问题,一旦遇到这种问题,常常就很扯蛋,每个人都不愿意承认是自己的代码有问题.其实编码问题并没有那么神秘,那么不可捉摸,搞清Java的编码本质过程就真相大白了.               其实,编码问题存在两个方面:JVM之内和JVM之外.   1.Java文件编译后形成class 这里Java文件的编码可能有多种多样,但Java编译器会自动将这些编码按照Java文件的编码格式正确读取后产生class文件,这里的class文件编码是Unicode编码(具体说是UT			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE4lBnz.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;Java ClassLoader解析一（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jvm classLoader architecture: Bootstrap ClassLoader/启动类加载器  主要负责jdk_home/lib目录下的核心 api 或 -Xbootclasspath 选项指定的jar包装入工作. Extension ClassLoader/扩展类加载器  主要负责jdk_home/lib/ext目录下的jar包或 -Djava.ext.dirs 指定目录下的jar包装入工作. System ClassLoader/系统类加载器  主要负责java -c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgRGv1b.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;Java ClassLoader解析二（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.什么是ClassLoader?          大家都知道,当我们写好一个Java程序之后,不是管是CS还是BS应用,都是由若干个.class文件组织而成的一个完整的Java应用程序,当程序在运行时,即会调用该程序的一个入口函数来调用系统的相关功能,而这些功能都被封装在不同的class文件当中,所以经常要从这个class文件中要调用另外一个class文件中的方法,如果另外一个文件不存在的,则会引发系统异常.而程序在启动的时候,并不会一次性加载程序所要用的所有class文件,而是根据程序的需			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Z6jAz.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;JAVA IO 设计模式彻底分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文转载于网络. 一.引子(概括地介绍Java的IO) 无论是哪种编程语言,输入跟输出都是重要的一部分,Java也不例外,而且Java将输入/输出的功能和使用范畴做了很大的扩充.它采用了流的 机制来实现输入/输出,所谓流,就是数据的有序排列,而流可以是从某个源(称为流源或Source of Stream)出来,到某个目的地(称为流汇或Sink of Stream)去的.由流的方向,可以分成输入流和输出流,一个程序从输入流读取数据向输出流写数据. 如,一个程序可以用FileInputStream类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQxeVp.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;在Dos环境下Java内部类的编译和运行</a>
			</h2>
		</header>
		<article class="clearfix">
									<a href="https://www.iamivan.net/a/zVQxeVp.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzExMDcxMTM4MDM3MTg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YjNWNVlXNW5YM0JsYm1jPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
							</a>
						<div class="summary">
				习惯了在IDE工具上进行代码编写,连最基本的Javac命令和Java命令都忘记的差不多了,今天对一个Java内部类进行编译和运行的时候,就出糗了.IDE是把双刃剑,它可以什么都帮你做了,你只要敲几行代码,点几下鼠标,程序就跑起来了,用起来相当方便.你不用去关心它后面做了些什么,执行了哪些命令,基于什么原理.然而也是这种过分的依赖往往让人散失了最基本的技能,当到了一个没有IDE的地方,你便觉得无从下手,给你个代码都不知道怎么去跑. 首先我在C盘上编写了一个InnerClassTest.java代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Qvemp.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;工具类：Java获取字符串和文件进行MD5值</a>
			</h2>
		</header>
		<article class="clearfix">
									<a href="https://www.iamivan.net/a/M0Qvemp.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzExMDcxMTM4MDM3MTg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YjNWNVlXNW5YM0JsYm1jPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
							</a>
						<div class="summary">
				ps:这几天本人用百度云盘秒传了几部大片到云盘上,几个G的文件瞬秒竟然显示&quot;上传成功&quot;!这真让我目瞪口呆,要是这样的话,那得多快的网速,这绝对是不可能的,也许这仅是个假象.百度了一下才发现所谓的&quot;秒传&quot;是常见的&quot;忽略式&quot;上传方式,就是您上传了一个文件名为111.exe,MD5为一个数,有一个网友以前也上传一个叫222.exe,MD5和您上传的文件MD5码一模一样,所以这个文件上传到服务器上的时间就很短了,这是因为别人上传过这个文件,您上传这个文件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeRaRVb.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;交通灯管理系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.交通灯管理系统的项目需求 模拟实现十字路口的交通灯管理系统逻辑,具体需求如下: Ø         异步随机生成按照各个路线行驶的车辆. 例如: 由南向而来去往北向的车辆 ---- 直行车辆        由西向而来去往南向的车辆 ---- 右转车辆        由东向而来去往南向的车辆 ---- 左转车辆        ... Ø         信号灯忽略黄灯,只考虑红灯和绿灯. Ø         应考虑左转车辆控制信号灯,右转车辆不受信号灯控制. Ø         具体信号灯控制			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxOwjb.html" rel="bookmark" class="title">如何利用MySQL加密函数保护Web网站敏感数据</a>
					<div>
						如果您正在运行使用MySQL的Web应用程序,那么它把密码或者其他敏感信息保存在应用程序里的机会就很大.保护这些数据免受黑客或者窥探者的获取是一个令人关注的重要问题,因为您既不能让未经授权的人员使用或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvarVb.html" rel="bookmark" class="title">Flash MX 2004新特性</a>
					<div>
						Flash MX的最新版本名命名为Flash MX 2004,分为专门面向设计者的Flash MX 2004和专门面向开发者的Flash MX 2004 Professional. 下面我们分别介绍F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeen8z.html" rel="bookmark" class="title">Microsoft &period;NET Development Platform的Linux版本（Mono）出现</a>
					<div>
						development Microsoft .NET development platform的Linux版本(Mono)出现. 一家叫Ximian的公司在2001-07-09宣布了Mono proj ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2n1ab.html" rel="bookmark" class="title">STAF学习系列--安装及配置</a>
					<div>
						1.JDK安装及配置: (1)默认安装JAK,路径如:C:\jdk1.5.0_11 JDK下载地址http://java.sun.com/javase/downloads/index.jsp (2)配 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Amoqp.html" rel="bookmark" class="title">Photoshop毛发抠图常用方法</a>
					<div>
						1.在通道面板里,通过观察比较发现,红通道的对比最为强烈,因此复制一份.Ctrl+L,调整色阶. 图39 2.用画笔把整个猫身内部涂白. 图40 3.按住Ctrl单击红色通道,得到选区.适当调整选区范 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7VL2M.html" rel="bookmark" class="title">Javascript 遮罩层和加载效果</a>
					<div>
						 //loading function showLoad(tipInfo) { var iWidth = 120; //弹出窗口的宽度; var iHeight = 0; //弹出窗口的高度; var ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7P5NM.html" rel="bookmark" class="title">win7系统IE浏览器提示运行错误是否纠正错误怎么办？</a>
					<div>
						  win7系统IE浏览器提示运行错误是否纠正错误怎么办?          方法一: 1.打开IE浏览器,从右上角打开Internet选项; 2.点击切换到&quot;高级&quot;选项卡; 3. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlR7Rqz.html" rel="bookmark" class="title">Excel2010如何绘制双纵坐标轴？</a>
					<div>
						  1.打开Excel文档,选中需要绘制双纵坐标轴的单元格数据,接着点击工具栏的&quot;插入&quot;→&quot;图表&quot;→&quot;柱形图&quot;→&quot;二维柱形图&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQN1NZM.html" rel="bookmark" class="title">Linux如何查看so中函数名</a>
					<div>
						  Linux如何查看so中函数名 很多非常熟悉windows 进程依赖那个dll, 使用depends,linux使用ldd命令. 查看函数windows使用dumpbin,linux使用 objd ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8lmqp.html" rel="bookmark" class="title">阿里云邮箱的SMTP是什么</a>
					<div>
						  SMTP 的全称是&quot;Simple Mail Transfer Protocol&quot;,即简单邮件传输协议.它是一组用于从源地址到目的地址传输邮件的规范,通过它来控制邮件的中转方式. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8NjKb.html" rel="bookmark" class="title">快用苹果助手怎么样</a>
					<div>
						  1.下载&quot;快用苹果助手&quot; 2.将下载好的exe文件安装完成之后,打开运行快用苹果助手.首先看到就是许多的软件图标,这时注意到窗口左下方提示&quot;您的设备尚未连接电脑,请插 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WGNnb.html" rel="bookmark" class="title">uva 10891 - Game of Sum</a>
					<div>
						题意:    A,B两人依次从数组两边拿数字,每次任选一边拿走1+个,A先手,问最后A比B大多少 设代表i,j子序列先手可以取得的最大差值 转移方程为 有个状态,个转移,总复杂度为结果为f(1,n)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7xDWz.html" rel="bookmark" class="title">PHP连接MSSQL配置教程</a>
					<div>
						配置php 1.打开php.in将extension=php_mssql.dll的注释符号去掉. 2.打开php.in将mssql.secure_connection = Off改为on. 3.将ph ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3rJkz.html" rel="bookmark" class="title">oracle中Frequent generate a lot of cdmp&ast; directories contain &ast;bucket trace in bdump问题分析</a>
					<div>
						最近有套库突然目录使用告警,发现TRACE 目录使用较高,发现在bdump 目录中每分钟都生成一个cdmp*目录,且每个目录中含大量的文件,这是一套oracle 11.2.0.3 rac on hpu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YxZqM.html" rel="bookmark" class="title">volley框架服务端接受代码</a>
					<div>
						问题描述 volley框架服务端接受代码 客户端用volley框架写的,服务端不知道怎么接受客户端发来的请求,求大神帮忙啊!!! 急急急!!! 客户端请求为: public void testVoll ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEk54p.html" rel="bookmark" class="title">ImageZoom 图片放大效果</a>
					<div>
						这个效果也叫放大镜效果,最早好像在ppg出现的,之后就有了很多仿制品出来了. 一般用于放大查看商品图片,在凡客,京东商城,阿里巴巴等都有类似的效果. 好处是能在原图附近对图片进行局部放大查看,而且可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwZ9QM.html" rel="bookmark" class="title">qq侧滑</a>
					<div>
						上一篇博客带大家实现了:Android 自定义控件打造史上最简单的侧滑菜单 ,有兄弟看了以后说,你这滑动菜单过时了呀~QQ5.0的效果还不错~~嗯,的确,上一篇也承诺过,稍微修改上一篇的代码,实现QQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7G2WM.html" rel="bookmark" class="title">求大神介绍个带搜索的下拉框控件！js最佳</a>
					<div>
						问题描述 类似这样的!急急急!!!! 解决方案 解决方案二: 解决方案三:楼主图片的那个太丑,给你个老外弄的http://thecodeblock.com/suggestions-search-box ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rjANz.html" rel="bookmark" class="title">关于三网合并工程</a>
					<div>
						问题描述 有线电视信号与卫星电视信号及2.4G网络信号同轴电缆共缆传输工程详情请咨询15275124080					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR0d5b.html" rel="bookmark" class="title">【Python之旅】第四篇（一）：Python装饰器</a>
					<div>
						有时候拿到一个程序接口,需要对其进行扩展,但是又不能修改原来接口的源代码,这时候就需要使用装饰器了.     有下面一个小程序,假如是别人提供给我们的调用接口: 1 2 3 4 5 import ti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV03yDM.html" rel="bookmark" class="title">dede自动获取关键字设置详解</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 也是一件老生常谈的事情,我也老怕自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKWj2z.html" rel="bookmark" class="title">急求c&num; 与三菱plc 以太网通讯 案例 源代码</a>
					<div>
						问题描述 希望有案例的源代码哦 解决方案 解决方案二:最好向三菱官方请求技术支持					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXPrjz.html" rel="bookmark" class="title">阿里妈妈在北京举办无线营销一触即发无线营销平台发布会</a>
					<div>
						10月18日,阿里妈妈在北京举办&quot;无线营销·一触即发&quot;无线营销平台发布会,正式启动&quot;智无线&quot;平台.该平台拥有淘宝直通车无线端推广.钻石展位无线端推广.无线电商墙 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJKRkp.html" rel="bookmark" class="title">《Adobe Audition CS6中文版经典教程》&mdash;&mdash;1&period;5　使用外置接口设备</a>
					<div>
						1.5 使用外置接口设备 这里不可能提供练习,因为笔者无法知道读者使用什么接口设备.然而,在使用外置接口设备时应注意以下几点. 由于专业接口设备的功能通常超出内置音频提供的功能,因此有其自己的控制面板 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7gkOz.html" rel="bookmark" class="title">通过可视化更好的了解你的Spark应用</a>
					<div>
						图的最大价值是它会推动我们去注意到那些我们从未预料到的东西. – John Tukey Spark 1.4中对Spark UI进行改进,更加突出可视化的效果.我们来看一下他的主要的改动,主要包含三个方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWW4rmM.html" rel="bookmark" class="title">网络-关于多级路由组播问题</a>
					<div>
						问题描述 关于多级路由组播问题 请教问题,请高手不吝赐教 在一个局域网中有两个路由器Rouer-A和Router-B(假设都不支持组播功能),两个路由器下面分别有两台主机PC-A和PC-B,PC-A和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YP39z.html" rel="bookmark" class="title">logger在java中定义的意思</a>
					<div>
						问题描述 logger在java中定义的意思 是在BatchJob类中加入这个语句的意思,求解释详细点哦 protected static Logger logger = Logger.getLogg ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnwG9M.html" rel="bookmark" class="title">《R语言机器学习：实用案例分析》&mdash;&mdash;第1章开始使用R语言和机器学习</a>
					<div>
						第1章 开始使用R语言和机器学习 本章是介绍性的,它将让你从基础部分学习R语言,包括R语言的各种元素.有用的数据结构.循环和向量化.如果你已经是一个R语言行家,你可以跳过这部分,直接进入下一章.下一章 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2dQVM.html" rel="bookmark" class="title">Python错误和异常的使用详解</a>
					<div>
						&gt;&gt;&gt; for i in range(10)  File &quot;&lt;stdin&gt;&quot;, line 1    for i in range(10)        ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8LAjb.html" rel="bookmark" class="title">浅谈javascript中的三种弹窗&lowbar;javascript技巧</a>
					<div>
						js中三种弹窗 1)alert 弹出警告 无返回值---------alert('第一行\n第二行'); 2)confirm()选择确定或取消,返回t或f----var result = confir ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.096 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
